% Archivo de tratamiento de datos Datos_Experimentales_TFG.m
% Autor: YOUSSEF EL OUARDI 
% PROTECCIN FRENTE A LA CORROSIN DE ESPUMAS DE MAGNESIO CON APLICAIONES
% BIOMDICAS

%% Cargar los datos experimentales

Rp = xlsread('Datos_exp.xlsx','Rp_BSARGO');
Tafel = xlsread('Datos_exp.xlsx','Tafel_BSARGO');
Impedancia = xlsread('Datos_exp.xlsx','IMPEDANCIA');

%% Datos de Rp
% Valores de Rp del primer experimeto 

x_M0 = Rp(1:20,19); y_M0 = Rp(1:20,20);

x_E1RGO = Rp(1:20,1); y_E1RGO = Rp(1:20,2); % Rp Electroqumico x(V) e y(A)

x_Q1RGO = Rp(1:20,4); y_Q1RGO = Rp(1:20,5); % Rp Qumico PAS/BSA/1 RGO

x_Q2GO = Rp(1:20,10); y_Q2GO = Rp(1:20,11); % Rp Qumico PAS/BSA/ 2 GO r.p.

x_Q4GO = Rp(1:20,7); y_Q4GO = Rp(1:20,8); % Rp Qumico PAS/BSA/ 4 GO r.p.

% Valores de Rp del segundo experimento

x_QRGO2 = Rp(1:20,16); y_QRGO2 = Rp(1:20,17); % Rp Qumico PAS/BSA/ 2RGO

x_QRGO4 = Rp(1:20,13); y_QRGO4 = Rp(1:20,14); % Rp Qumico PAS/BSA/ 4RGO

x_QRGO6 = Rp(25:44,10); y_QRGO6 = Rp(25:44,11); % Rp Qumico PAS/BSA/ 6RGO

x_QMDit = Rp(25:44,16); y_QMDit = Rp(25:44,17); % Rp Qumico Mg/Dit 1 hora

% Valores de Rp del tercer experimento

x_MRGO4 = Rp(25:44,1); y_MRGO4 = Rp(25:44,2); % Rp Qumico Mg/4RGO

x_MPRGO4 = Rp(25:44,4); y_MPRGO4 = Rp(25:44,5); % Rp Qumico Mg/PAS/4RGO

x_MBRGO4 = Rp(25:44,7); y_MBRGO4 = Rp(25:44,8); % Rp Qumico Mg/BSA/4RGO

x_MPLRGO4 = Rp(25:44,13); y_MPLRGO4 = Rp(25:44,14); % Rp Qumico Mg/PLASMA/BSA/4RGO


%% Datos de Tafel

A = 0.282; % Superficie del electrodo cm^2

% Valores de Tafel del primer experimeto 

xT_M0 = Tafel(2:end,49); yT_M0 = abs(Tafel(2:end,50)/A)*1000;

xT_E1RGO = Tafel(2:end,1); yT_E1RGO = abs(Tafel(2:end,2)/A)*1000; % Rp Electroqumico x(V) e y(mA/cm^2)

xT_Q1RGO = Tafel(2:end,5); yT_Q1RGO = abs(Tafel(2:end,6)/A)*1000; % Rp Qumico PAS/BSA/1 RGO

xT_Q2GO = Tafel(2:end,13); yT_Q2GO = abs(Tafel(2:end,14)/A)*1000; % Rp Qumico PAS/BSA/ 2 GO r.p.

xT_Q4GO = Tafel(2:end,9); yT_Q4GO = abs(Tafel(2:end,10)/A)*1000; % Rp Qumico PAS/BSA/ 4 GO r.p.

% Valores de Tafel del segundo experimento

xT_QRGO2 = Tafel(2:end,21); yT_QRGO2 = abs(Tafel(2:end,22)/A)*1000; % Rp Qumico PAS/BSA/ 2RGO

xT_QRGO4 = Tafel(2:end,17); yT_QRGO4 = abs(Tafel(2:end,18)/A)*1000; % Rp Qumico PAS/BSA/ 4RGO

xT_QRGO6 = Tafel(2:end,45); yT_QRGO6 = abs(Tafel(2:end,46)/A)*1000; % Rp Qumico PAS/BSA/ 6RGO

xT_QMDit = Tafel(2:end,41); yT_QMDit = abs(Tafel(2:end,42)/A)*1000; % Rp Qumico Mg/Dit 1 hora

% Valores de Tafel del tercer experimento

xT_MRGO4 = Tafel(2:end,33); yT_MRGO4 = abs(Tafel(2:end,34)/A)*1000; % Rp Qumico Mg/4RGO

xT_MPRGO4 = Tafel(2:end,25); yT_MPRGO4 = abs(Tafel(2:end,26)/A)*1000; % Rp Qumico Mg/PAS/4RGO

xT_MBRGO4 = Tafel(2:end,29); yT_MBRGO4 = abs(Tafel(2:end,30)/A)*1000; % Rp Qumico Mg/BSA/4RGO

xT_MPLRGO4 = Tafel(2:end,37); yT_MPLRGO4 = abs(Tafel(2:end,38)/A)*1000; % Rp Qumico Mg/PLASMA/BSA/4RGO

%% Datos de IMPEDANCIA

% Valores de IMPEDANCIA del primer experimeto 

xI_M0 = Impedancia(1:36,37); yI_M0 = Impedancia(1:36,38);

xI_E1RGO = Impedancia(1:37,1); yI_E1RGO = Impedancia(1:37,2); % Rp Electroqumico x(ohm Z'') e y(ohm Z')

xI_Q1RGO = Impedancia(1:31,4); yI_Q1RGO = Impedancia(1:31,5); % Rp Qumico PAS/BSA/1 RGO

xI_Q2GO = Impedancia(1:26,10); yI_Q2GO = Impedancia(1:26,11); % Rp Qumico PAS/BSA/ 2 GO r.p.

xI_Q4GO = Impedancia(1:35,7); yI_Q4GO = Impedancia(1:35,8); % Rp Qumico PAS/BSA/ 4 GO r.p.

% Valores de IMPEDANCIA del segundo experimento

xI_QRGO2 = Impedancia(1:37,16); yI_QRGO2 = Impedancia(1:37,17); % Rp Qumico PAS/BSA/ 2RGO

xI_QRGO4 = Impedancia(1:42,13); yI_QRGO4 = Impedancia(1:42,14); % Rp Qumico PAS/BSA/ 4RGO

xI_QRGO6 = Impedancia(1:50,31); yI_QRGO6 = Impedancia(1:50,31); % Rp Qumico PAS/BSA/ 6RGO

xI_QMDit = Impedancia(1:28,34); yI_QMDit = Impedancia(1:28,35); % Rp Qumico Mg/Dit 1 hora

% Valores de IMPEDANCIA del tercer experimento

xI_MRGO4 = Impedancia(1:29,25); yI_MRGO4 = Impedancia(1:29,26); % Rp Qumico Mg/4RGO

xI_MPRGO4 = Impedancia(1:31,19); yI_MPRGO4 = Impedancia(1:31,20); % Rp Qumico Mg/PAS/4RGO

xI_MBRGO4 = Impedancia(1:26,22); yI_MBRGO4 = Impedancia(1:26,23); % Rp Qumico Mg/BSA/4RGO

xI_MPLRGO4 = Impedancia(1:30,28); yI_MPLRGO4 = Impedancia(1:30,29); % Rp Qumico Mg/PLASMA/BSA/4RGO

%% Datos Simulados de IMPEDANCIA


% Valores de IMPEDANCIA del primer experimeto 

xxI_E1RGO = linspace(xI_E1RGO(1),xI_E1RGO(end),7000);
xxI_Q1RGO = linspace(xI_Q1RGO(1),xI_Q1RGO(end),7000);
xxI_Q2GO = linspace(xI_Q2GO(1),xI_Q2GO(end),7000);
xxI_Q4GO = linspace(xI_Q4GO(1),xI_Q4GO(end),7000);
xxI_M0 =   linspace(xI_M0(1),xI_M0(end),7000);

yyI_M0 = interp1(xI_M0,yI_M0,xxI_M0,'PCHIP');
yyI_E1RGO = interp1(xI_E1RGO,yI_E1RGO,xxI_E1RGO,'PCHIP'); 
yyI_Q1RGO = interp1(xI_Q1RGO,yI_Q1RGO,xxI_Q1RGO,'PCHIP'); 
yyI_Q2GO = interp1(xI_Q2GO,yI_Q2GO,xxI_Q2GO,'PCHIP'); 
yyI_Q4GO = interp1(xI_Q4GO,yI_Q4GO,xxI_Q4GO,'PCHIP');

% Valores de IMPEDANCIA del segundo experimento

xxI_QRGO2 = linspace(xI_QRGO2(1),xI_QRGO2(end),7000);
xxI_QRGO4 = linspace(xI_QRGO4(1),xI_QRGO4(end),7000);
xxI_QRGO6 = linspace(xI_QRGO6(1),xI_QRGO6(end),7000);
xxI_QMDit = linspace(xI_QMDit(1),xI_QMDit(end),7000);

yyI_QRGO2 = interp1(xI_QRGO2,yI_QRGO2,xxI_QRGO2,'PCHIP'); 
yyI_QRGO4 = interp1(xI_QRGO4,yI_QRGO4,xxI_QRGO4,'PCHIP');
yyI_QRGO6 = interp1(xI_QRGO6,yI_QRGO6,xxI_QRGO6,'PCHIP');
yyI_QMDit = interp1(xI_QMDit,yI_QMDit,xxI_QMDit,'PCHIP');

% Valores de IMPEDANCIA del tercer experimento

xxI_MRGO4 = linspace(xI_MRGO4(1),xI_MRGO4(end),7000);
xxI_MPRGO4 = linspace(xI_MPRGO4(1),xI_MPRGO4(end),7000);
xxI_MBRGO4 = linspace(xI_MBRGO4(1),xI_MBRGO4(end),7000);
xxI_MPLRGO4 = linspace(xI_MPLRGO4(1),xI_MPLRGO4(end),7000);

yyI_MRGO4 = interp1(xI_MRGO4,yI_MRGO4,xxI_MRGO4,'PCHIP');
yyI_MPRGO4 = interp1(xI_MPRGO4,yI_MPRGO4,xxI_MPRGO4,'PCHIP');
yyI_MBRGO4 = interp1(xI_MBRGO4,yI_MBRGO4,xxI_MBRGO4,'PCHIP');
yyI_MPLRGO4 = interp1(xI_MPLRGO4,yI_MPLRGO4,xxI_MPLRGO4,'PCHIP');


